* Program to provide help HELP_EXT screens for all added toolkit commands.
* Once assembled, the program HELP_BAS must be used to add the
* descriptions to it. Then every time HELP_EXT is entered, (after having
* invoked it by a=RESPR(4000):LBYTES mdv1_help_ext,a:CALL a )
* the help sheets will be called up.
* 1987 R.A.MELLOR
*
* NOTE - There are two versions which may be used of this command
*  If entered in form HELP_EXT ,then all of the help screens will be
*  printed out but if it is entered in form HELP_EXT 'command' (eg
*  HELP_EXT 'squeeze' ),it will give information on just the specified
*  command (here being SQUEEZE)
*
*   TRAP #1 Codes
MT_DMODE    EQU      $10
MT_ALCHP    EQU      $18
MT_RECHP    EQU      $19
*   TRAP #2 Codes
IO_OPEN     EQU      $01
IO_CLOSE    EQU      $02
*   TRAP #3 Codes
IO_FBYTE    EQU      $01
IO_SSTRG    EQU      $07
SD_BORDR    EQU      $0C
SD_WDEF     EQU      $0D
SD_TAB      EQU      $11
SD_NL       EQU      $12
SD_CLEAR    EQU      $20
SD_SETPA    EQU      $27
SD_SETST    EQU      $28
SD_SETIN    EQU      $29
SD_SETUL    EQU      $2B
BV_CHBAS    EQU      $30

*   Vector Codes
CA_GTSTR    EQU      $116
BP_INIT     EQU      $110

            LEA      PROC_DEF,A1         Set up extra command 'HELP_EXT'
            MOVE.W   BP_INIT,A2
            JSR      (A2)
*
* REASSERT EXTENSIONS
*
            LEA.L    PROC_DEF,A0         Program by Tony Tebby to enable
            MOVE.W   #$0800,D5            extensions to be used in
REASSERT    ADDQ.L   #2,A0                the program which invokes them.
PT_LOOP     MOVEA.L  A0,A5
            MOVE.W   (A0)+,D0
            BEQ.S    ALL_DONE
            ADDA.W   D0,A5
            MOVE.B   (A0),D6
            SUBQ.L   #1,A0
            MOVE.L   $18(A6),A3
NT_ENTRY    MOVE.L   0(A6,A3.L),D0
            BEQ.S    NT_NEXT
            MOVE.L   $20(A6),A1
            ADDA.W   D0,A1
            SUBQ.L   #1,A1
            BSR      UT_CNMAR
            BNE.S    NT_NEXT
            MOVE.W   D5,0(A6,A3.L)
            MOVE.L   A5,4(A6,A3.L)
            MOVEA.L  A0,A2
            ADDQ.L   #2,A2
            MOVE.B   D6,D0
NM_LOOP     MOVE.B   (A2)+,2(A6,A1.L)
            ADDQ.L   #1,A1
            SUBQ.B   #1,D0
            BGT.S    NM_LOOP
            BRA.S    PT_NEXT
NT_NEXT     ADDQ.L   #8,A3
            CMPA.L   $1C(A6),A3
            BLT.S    NT_ENTRY
PT_NEXT     AND.W    #$00FE,D6
            ADDA.W   D6,A0
            ADDQ.W   #3,A0
            BRA.S    PT_LOOP
ALL_DONE    BSET     #8,D5
            BEQ.S    REASSERT
            MOVEQ    #0,D0
            RTS
UT_CNMAR    TRAP     #0
            ADDA.L   A6,A1
            BSR.S    UT_CNAMA
            SUBA.L   A6,A1
            ANDI.W   #$D8FF,SR
            RTS
UT_CNAMA    MOVEM.L  A0/A1,-(A7)
            MOVEQ    #0,D0
            ADDQ.L   #1,A0
            MOVE.B   (A0)+,D0
            ADDQ.L   #1,A1
            CMP.B    (A1)+,D0
            BRA.S    CN_LEND
CN_LOOP     BSR.S    CN_UC
            BSR.S    CN_UC
            CMP.B    D1,D2
CN_LEND     DBNE     D0,CN_LOOP
CN_EXIT     MOVEM.L  (A7)+,A0/A1
            RTS
CN_UC       EXG      A0,A1
            MOVE.B   D1,D2
            MOVE.B   (A1)+,D1
            CMP.B    #'a',D1
            BCS.S    UC_RTS
            CMP.B    #'z',D1
            BLS.S    UC_SET
            CMP.B    #$80,D1
            BCS.S    UC_RTS
            CMP.B    #$8B,D1
            BHI.S    UC_RTS
UC_SET      BCHG     #5,D1
UC_RTS      RTS
PROC_DEF    DC.W     1                   One Procedure Added
            DC.W     HELP_EXT-*
            DC.B     8,'HELP_EXT'
            DC.W     0                   Seperator
            DC.W     0                   No Functions Added
            DC.W     0                   End of Definitions
QDOS        MACRO
            MOVEQ    #\1,D0
            TRAP     #\2
            ENDM
*       Print strings passed to it in A1
OUTPUT
            QDOS     IO_SSTRG,3
            BSR      NEW_LINE
            RTS
INFO_OUTPUT
            QDOS     IO_SSTRG,3
            MOVE.W   (A1),D1
            BEQ.S    NOMORE
            BSR      NEW_LINE
NOMORE      RTS
INK         MOVEM.L  A1,-(A7)            Alter INK colour to D1
            QDOS     SD_SETIN,3
            MOVEM.L  (A7)+,A1
            RTS
*       Clear screen
CLEAN
            QDOS     SD_CLEAR,3
            RTS
*       Alter PAPER colour to D1
PAPER
            QDOS     SD_SETPA,3
            RTS
EMPTY       MOVEM.L  A1,-(A7)            Set up an empty TV screen to
            LEA.L    DATUM,A4             print the help pages on
            MOVEA.L  4(A4),A0
            BSR.S    EMPTY_ALL
            MOVEA.L  (A4),A0
            BSR.S    EMPTY_ALL
            MOVEM.L  (A7)+,A1
            RTS
EMPTY_ALL   MOVEQ    #-1,D3
            MOVEQ    #0,D1               Set strip colour to zero
            QDOS     SD_SETST,3
            BSR.S    PAPER
            BSR      CLEAN
            RTS
RESERVE     MOVE.L   #$8000,D1           Save screen memory
            MOVEQ    #-1,D2              Reserve some space in the
            QDOS     MT_ALCHP,1           common heap area to copy the
            LEA.L    BASE,A1              area of screen used by the
            MOVE.L   A0,(A1)              program to, and store its
            CMP.B    #-3,D0               address at BASE
            BEQ.S    EEXIT               OUT OF MEMORY
            MOVE.L   #$3FFF,D1
            MOVEA.L  #$20000,A1          Copy the area of screen used
COPY        MOVE.W   (A1)+,(A0)+          to storage pointed to by the
            DBF      D1,COPY              address held at BASE
            MOVEQ    #-1,D1              In case accidentally run in
            BSR.S    SET_MODE             MODE 8: Save old display at NORM
            LEA      NORM,A1              then set up MODE 4 for the
            CMP.B    #0,D1                help pages
            BEQ.S    NOFOOL
            MOVE.B   #1,(A1)
            MOVEQ    #0,D1
            BSR.S    SET_MODE
            RTS
SET_MODE
            QDOS     MT_DMODE,1
            RTS
NOFOOL      MOVE.B   #0,(A1)
            RTS
SET_UP      BSR.S    RESERVE
            TST.L    D0                  Any errors?
            BNE.S    EEXIT
            LEA.L    PARAMETER1,A0
            BSR.S    OPEN_SCR
            LEA.L    PARAMETER2,A0
            BSR.S    OPEN_CON
            MOVEQ    #0,D0
EEXIT       RTS
OPEN_SCR    MOVEQ    #2,D3               Open up the two channels needed
            BSR.S    OPEN_IT              for the output
            LEA.L    DATUM,A4            Then store the channel numbers
            MOVE.L   A0,(A4)              at DATUM
            RTS
OPEN_CON    BSR.S    OPEN_IT
            MOVE.L   A0,4(A4)
            RTS
OPEN_IT     MOVEQ    #-1,D1
            QDOS     IO_OPEN,2
            RTS
PARAMETER1  DC.W     17                  Screen definintion tables
            DC.B     'SCR_448x200a32x16'
            CNOP     0,2
PARAMETER2  DC.W     21
            DC.B     'CON_448x40a32x216_128'
            CNOP     0,2
PARAMETER3  DC.W     15
            DC.B     'SCR_10x10a32x16'
            CNOP     0,2
PARAMETER4  DC.W     20
            DC.B     'CON_200x10a32x16_128'
ANYOTHER    MOVE.W   2(A1),D0            Check second word in definition
            ADDA.L   #4,A1                tables as to whether there
            RTS                           are any descriptions here.
STORE       LEA.L    DATUM,A4
            MOVE.L   A1,8(A4)
            LEA.L    DATA,A4
            MOVE.W   D2,(A4)
            BSR      NEWTITLE
RETURN      RTS
HELP_EXT    MOVE.W   CA_GTSTR,A0         See if are any parameters
            JSR      (A0)                 following 'HELP_EXT'
            BNE.S    OOPS                Some error on parameter
            CMP.W    #0,D3               No parameter -
            BEQ.S    NOCOMM               Want all descriptions
            CMP.W    #1,D3
            BEQ      ONECOMM             Only one parameter
            MOVE.L   #-15,D0             BAD PARAMETER error
OOPS        RTS
PREPARE     BSR      PRINTS
            BSR      NEWSCREEN
            RTS
CLS         LEA.L    FLAG,A1
            MOVE.B   D0,(A1)
CLS2        BSR      EMPTY
            BSR      SCREEN
            RTS
NOCOMM      BSR      SET_UP              Set out screen display
            BNE.S    RETURN              Any errors?
            BSR.S    CLS2                Print title
            LEA.L    DEFNS,A1            Tell SCREEN routine that it is
            BSR.S    ANYOTHER             to print PROCEDURES
            BEQ.S    NOPROCS
            MOVEM.L  A1,-(A7)
            LEA.L    FLAG,A1
            MOVE.B   D0,(A1)
            MOVEQ    #10,D2
            LEA.L    BUFFER2,A1
            BSR.S    STORE
            MOVEM.L  (A7)+,A1
            BSR.S    PREPARE
NOPROCS     BSR      ANYOTHER
            BEQ.S    NOFNS
            MOVEM.L  A1,-(A7)
            BSR.S    CLS
            MOVEQ    #9,D2
            LEA.L    BUFFER3,A1
            BSR      STORE
            MOVEM.L  (A7)+,A1            Tell SCREEN routine that it is
            BSR.S    PREPARE              now to print FUNCTIONS
NOFNS       BSR      ANYOTHER
            BEQ.S    ALLOVER
            MOVEM.L  A1,-(A7)
            BSR.S    CLS
            MOVEQ    #13,D2
            LEA.L    BUFFER4,A1
            BSR      STORE
            MOVEM.L  (A7)+,A1            Tell SCREEN routine that it is
            BSR.S    PREPARE              now to print MISCELLANEOUS
ALLOVER     LEA.L    LINES,A1
            MOVE.W   #239,D1
            MOVE.W   D1,(A1)
HELP_END    MOVE.B   NORM,D1             Return to BASIC with screen reset
            CMP.B    #0,D1                to what it was on entry:
            BEQ.S    GOODMAN              (ie. the same MODE and the same
            MOVEQ    #8,D1                 screen to replace that used
            BSR      SET_MODE              by this program)
GOODMAN     LEA.L    DATUM,A4
            MOVE.L   (A4),A0
            BSR.S    CLOSE_IT            Get rid of output channels
            MOVE.L   4(A4),A0
            BSR      CLOSE_IT
            MOVE.L   BASE,A0
            MOVE.W   #$3FFF,D1
            MOVEA.L  #$20000,A1
MOVER       MOVE.W   (A0)+,(A1)+         Copy the picture back onto the
            DBF      D1,MOVER             screen form where it was stored
            MOVE.L   BASE,A0              earlier during SET_UP
            QDOS     MT_RECHP,1
            RTS
CLOSE_IT
            QDOS     IO_CLOSE,2
            RTS
NEWTITLE    MOVEM.L  A1,-(A7)
            LEA.L    DATUM,A4            Find out whether it's procedures
            MOVE.L   8(A4),A1             or functions on this screen
            MOVE.W   DATA,D2
            BSR      OUTPUT
            MOVEM.L  (A7)+,A1
            RTS
PRINTS      MOVE.W   (A1),D2             Print out all of the commands
            CMPI.W   #0,D2                and functions until the word
            BNE.S    CARRYON              giving the length of the command
            RTS                           is zero
CARRYON     MOVE.W   2(A1),D5
            ADDQ.L   #4,A1
            MOVEQ    #2,D1
            BSR      INK                 Print out the commands in RED
            BSR      TAB                  and the information in GREEN
            BSR      OUTPUT
            MOVEQ    #4,D1
            BSR      INK
            MOVE.W   D5,D2
            CMP.W    #0,D2
            BEQ.S    FINISHED
            BSR      INFO_OUTPUT
FINISHED    BRA.S    PRINTS
MORE        MOVE.B   D2,D4
            MOVEA.L  A1,A2               SD.NL and SD.TAB affect A1 so
            MOVEM.L  D1/A0,-(A7)          its value must be stored.
            LEA.L    DATUM,A4
            MOVEA.L  4(A4),A0            Ask for key to be pressed
            BSR      NEW_LINE             before moving to next screen.
            MOVEQ    #20,D1
            BSR      TAB
            MOVEQ    #7,D1
            BSR      INK
            MOVE.B   D4,D2
            MOVEA.L  A2,A1
            BSR      OUTPUT
WAIT
            QDOS     IO_FBYTE,3
            TST.B    D1                  Wait for a key to be pressed.
            BEQ.S    WAIT
            MOVEM.L  (A7)+,D1/A0
            RTS
NEWSCREEN   MOVEM.L  A1,-(A7)
            MOVE.B   FLAG,D0
            CMP.B    #1,D0               Not last page
            BEQ.S    MOREPAGES
            LEA.L    MESSAGE2,A1
            MOVEQ    #32,D2
            BRA.S    EXTRAPAGE
MOREPAGES   LEA.L    MESSAGE1,A1         More to come...
            MOVEQ    #22,D2
EXTRAPAGE   BSR.S    MORE
            MOVEM.L  (A7)+,A1
            RTS
TAB         MOVEM.L  D1/A1,-(A7)         Move the cursor along the line
            QDOS     SD_TAB,3
            MOVEM.L  (A7)+,D1/A1
            RTS
SCREEN      MOVEM.L  A1,-(A7)
            MOVEQ    #7,D1               Print out the screen headings
            BSR      INK                  and title
            MOVEQ    #25,D1
            BSR.S    TAB
            MOVEQ    #1,D1
            BSR.S    UNDERLINE
            LEA.L    BUFFER1,A1
            MOVEQ    #13,D2
            BSR      OUTPUT
            MOVEQ    #0,D1
            BSR.S    UNDERLINE
            BSR.S    NEW_LINE
            MOVEQ    #7,D1
            BSR      INK
            MOVEM.L  (A7)+,A1
            RTS
NEWPAGE     MOVEM.L  A1/D0,-(A7)
            LEA.L    FLAG,A1
            MOVE.B   (A1),D0
            MOVEM.L  D0,-(A7)
            MOVE.B   #1,(A1)
            BSR.S    NEWSCREEN
            MOVEM.L  (A7)+,D0
            MOVE.B   D0,(A1)
            MOVEM.L  (A7)+,A1/D0
            BSR      EMPTY
            BSR.S    SCREEN
            BRA      NEWTITLE
            RTS
NEW_LINE
            QDOS     SD_NL,3
            CMP.W    #-4,D0              See if any room left on screen
            BEQ.S    NEWPAGE             If not then go to next page
            RTS
UNDERLINE
            QDOS     SD_SETUL,3
            RTS
ONECOMM     LEA.L    LEN,A2               Convert parameter to UPPER case
            MOVE.B   0(A6,A1.L),D1        Move to start of string
            BNE.S    SAVELEN               putting length of string at
            ADDQ     #1,A1                 LEN and string itself at
            BRA.S    ONECOMM               COMMAND
SAVELEN     MOVE.B   D1,(A2)
            ADDQ     #1,A1
            LEA.L    COMMAND,A2
MORECHRS    MOVE.B   0(A6,A1.L),D1
            BEQ.S    CONVERT              -- End of string ?? --
            CMP.B    #96,D1
            BLS.S    UPPER
            CMP.B    #122,D1
            BHI.S    UPPER
            SUBI     #32,D1               Convert to UPPER case if
UPPER       MOVE.B   D1,(A2)               necessary
            ADDQ     #1,A2
            ADDQ     #1,A1
            BRA.S    MORECHRS
ENDING      ADDQ     #1,D2
            CMP.B    #3,D2
            BNE.S    LOOPER
            MOVEQ    #-7,D0               NOT FOUND error
            RTS
CONVERT     LEA.L    DEFNS,A1
            MOVEQ    #0,D2
LOOPER      BSR      ANYOTHER
            BEQ.S    ENDING
FIND_INFO   LEA.L    STORAGE,A4
            MOVE.L   A1,(A4)
            MOVE.W   (A1),D0              If no more definitions in this
            BEQ.S    LOOPER                section then move to next.
            LEA.L    LEN,A0
            MOVE.B   (A0),D4
            ADDQ     #1,A0
            ADDQ     #4,A1
POSS        SUBI.B   #1,D4                Once a definition is found
            BEQ.S    FOUND                 compare all of the characters
            MOVE.B   (A1),D1               to see if it is the desired
            MOVE.B   (A0),D3               command
            CMP.B    D1,D3
            BNE.S    DIFFERENT
            ADDQ     #1,A1
            ADDQ     #1,A0
            BRA.S    POSS                 Are all letters the same?
DIFFERENT   MOVE.L   STORAGE,A1           MOVE A1 TO START OF NEXT
            LEA.L    COMMAND,A0            DEFINITION
            MOVE.W   (A1),D1
            MOVE.W   2(A1),D3             Definitions are in order of
            ADDA.W   D1,A1                 two words containing length of
            ADDA.W   D3,A1                 command and information then
            ADDQ     #4,A1                 bytes containing the words
            BRA.S    FIND_INFO
FOUND       MOVE.L   STORAGE,A1
            MOVE.W   (A1),D2              Work out no of lines needed
            MOVE.W   2(A1),D3              to print out the information
            MOVEQ    #5,D1                 and then reserve the amount of
            DIVU.W   #74,D2                screen used and store its
            DIVU.W   #74,D3                contents so that they may be
            ADD.W    D2,D1                 restored afterwards
            ADD.W    D3,D1
            MULU.W   #10,D1
            LEA.L    LINES,A1
            MOVE.W   D1,(A1)
            BSR      RESERVE
            TST.L    D0
            BNE      EEXIT
            LEA.L    PARAMETER3,A0        Open two windows on screen both
            BSR      OPEN_SCR              in same place to print out
            LEA.L    PARAMETER4,A0         the information making the
            BSR      OPEN_CON              main screen deep enough to
            LEA.L    WINDOW,A1             contain the information
            LEA.L    LINES,A0              NB can't be over 21 lines
            MOVE.W   (A0),2(A1)            long (each line 74 characters)
            LEA.L    DATUM,A4
            MOVE.L   (A4),A0
            MOVE.B   #0,D1
            MOVE.W   #0,D2
            MOVE.W   #-1,D3
            QDOS     SD_WDEF,3
            BSR      EMPTY                Empty the screen and then
            QDOS     SD_NL,3               set it up to print out the
            MOVE.B   #2,D1                 information
            MOVE.W   #1,D2
            QDOS     SD_BORDR,3
            MOVE.L   STORAGE,A1
            MOVE.W   (A1),D2
            MOVE.W   2(A1),D5
            ADDQ.L   #4,A1
            MOVEQ    #7,D1
            BSR      INK                 Print out the commands in RED
            MOVEQ    #2,D1
            BSR      TAB                  and the information in GREEN
            BSR      OUTPUT
            MOVEQ    #4,D1
            BSR      INK
            MOVE.W   D5,D2
            BSR      OUTPUT
            QDOS     SD_NL,3
            MOVEQ    #7,D1
            BSR      INK
            MOVEQ    #20,D1
            BSR      TAB
            LEA.L    MESSAGE2,A1
            MOVE.W   #32,D2
            QDOS     IO_SSTRG,3
            LEA.L    DATUM,A4
            MOVE.L   4(A4),A0
PAUSE
            QDOS     IO_FBYTE,3
            TST.B    D1
            BEQ.S    PAUSE
            LEA.L    LINES,A1
            MOVE.W   (A1),D1
            SUBI.W   #1,D1
            MOVE.W   D1,(A1)
            BRA      HELP_END
BUFFER1     DC.B     'QL EXTENSIONS'

*--------------------------------------------------------------------------------------------
BUFFER2     DC.B     'PROCEDURES'
BUFFER3     DC.B     'FUNCTIONS'
BUFFER4     DC.B     'MISCELLANEOUS'
WINDOW      DC.W     448,10,32,16
            CNOP     0,2
LEN         DS.B     1
COMMAND     DS.B     128
STORAGE     DS.L     1
LINES       DS.W     1
DATUM       DS.L     3
BASE        DS.L     1
DATA        DS.W     1
NORM        DS.B     1
FLAG        DS.B     1
MESSAGE1    DC.B     'PRESS ANY KEY FOR REST'
MESSAGE2    DC.B     'PRESS ANY KEY TO RETURN TO BASIC'
            CNOP     0,2   ---- END WITH CODE ALIGNED ON WORD BOUNDARY -
DEFNS       DC.W     0

            END
